<?php 
/**
 * WooCommerce UUID Plugin Functions
 *
 * @author   d.stanisheva
 * @package  woo-uuid
 * @since    1.0.0
 */
// TIME INTERVAL
	add_filter('cron_schedules', 'woouuid_cron_add_intervals');
	function woouuid_cron_add_intervals( $schedules ) {
	  $schedules['checkuuid'] = array(
	    'interval' => 300,
	    'display' => __('Every 5min')
	  );
	  return $schedules;
	}

// SETUP CRON
  register_activation_hook(__FILE__, 'woouuid_schedule_cron');
  add_action('wp', 'woouuid_schedule_cron');
	add_action('woouuid_cron', 'woouuid_cron_function');
	function woouuid_schedule_cron() {
		
	  if ( !wp_next_scheduled( 'woouuid_cron' ) )
	    wp_schedule_event(time(), 'checkuuid', 'woouuid_cron');
	  
	}
	   
	function get_processing_orders() {
	  /* global $wpdb;
	   $processing_orders = $wpdb->get_col(
	      $wpdb->prepare(
		 "SELECT posts.ID
		 FROM {$wpdb->prefix}posts AS posts
		 WHERE posts.post_type = 'shop_order'
		 AND posts.post_status = 'wc-on-hold'
	         ")
	   );*/
	   
        $args = array(
			'status' => 'wc-processing', 
  			'return' => 'ids');
  			
	
	$processing_orders = wc_get_orders( $args );
	
        return $processing_orders;
	}
	
	
function woouuid_cron_function() {	   
	global $wpdb;
			  
	$results = $wpdb->get_results( "SELECT webhook_id, delivery_url, status, name FROM {$wpdb->prefix}wc_webhooks" );
	$hookisActiv = false;
	
	foreach($results as $result)
	{
		if(strpos($result->delivery_url, 'create-order-woocommerce') !== false &&  strpos($result->name, 'ICASH webhook') !== false )
		{
			if(strtolower($result->status) != 'active'){
				$hookisActiv = false;				
			} else {
				$hookisActiv = true;				
			}	
			break ;
		}
	}

	if($hookisActiv == false) 
		return; 

	$orders = get_processing_orders();
	$email_subject = "Completed Orders Email Digest";
        $email_content = "Completed Order IDs: " . implode( "|", $orders );
	       
        $warehouseID = get_option( 'warehouseid', true );		
	$domain      = get_option( 'domain', true );
	$onlineStoreID = get_option( 'onlineStoreID', true );

	foreach( $orders as $orderID){

		$order = wc_get_order( $orderID );
            	$order_data = $order->get_data(); // The Order data
			
		$hasCR = get_option( 'work_with_cashregister' );
			
		$data = array(
                	'orderID' => $orderID,
                	'whid'    => $warehouseID	,
			'onlineStoreID' => $onlineStoreID
            	);
            
            	$url = 'http://'.$domain.'/default/woocommerce/create-woo-order-by-id';

            	$response = wp_remote_post( $url , array('body' => $data, 'timeout' => 100 ));
            	$responceOperation = json_decode(wp_remote_retrieve_body( $response ), TRUE ); 

	}
}	
	register_deactivation_hook (__FILE__, 'woouuid_deactivate');
       
	function woouuid_deactivate() {	
		$timestamp = wp_next_scheduled ('woouuid_cron');		
		wp_unschedule_event ($timestamp, 'woouuid_cron');
	} 


