<?php 
/**
 * WooCommerce UUID Plugin Functions
 *
 * @author   d.stanisheva
 * @package  woo-uuid
 * @since    1.0.0
 */
//  TIME INTERVAL
	add_filter('cron_schedules', 'wooer_cron_add_intervals');
	
	function wooer_cron_add_intervals( $schedules ) {
	  $schedules['checker'] = array(
	    'interval' => 300,
	    'display' => __('Every 5min')
	  );
	  return $schedules;
	}

// SETUP CRON
    register_activation_hook(__FILE__, 'wooer_schedule_cron');

    add_action('wp', 'wooer_schedule_cron');
	
	function wooer_schedule_cron() {
	  if ( !wp_next_scheduled( 'wooer_cron' ) )
	    wp_schedule_event(time(), 'checker', 'wooer_cron');
	}


// the CRON hook for firing function
	add_action('wooer_cron', 'wooer_cron_function');
       // add_action('wp_head', 'woouuid_cron_function'); //test on page load

	function get_waitinger_orders() {
		
		$args = array(
			'status' => 'wc-waitinger', 
  			'return' => 'ids');
		$query = new WC_Order_Query( $args );
		$waitingER_orders = $query->get_orders();
	
	    return $waitingER_orders;
	}

	

	function wooer_cron_function() {	   
	    
		$orders = get_waitinger_orders();
		$email_subject = "WaitingER";
        $email_content = "WaitingER Order IDs: " . implode( "|", $orders );	        
		
		$warehouseID = get_option( 'warehouseid', true );		
		$domain      = get_option( 'domain', true );

		foreach( $orders as $orderID){

			$order = wc_get_order( $orderID );
            $order_data = $order->get_data(); // The Order data
			
			$hasCR = get_option( 'work_with_cashregister' );
			             	       
			if($hasCR ){

				$operationID = get_post_meta( $orderID, 'opID', true );
 
				if(isset($operationID) && !empty($operationID)){

	 				$data = array(
						'operationID' => $operationID,
						'whid'        => $warehouseID			
					);				
					

                    $url = 'http://'.$domain.'/default/woocommerce/get-electronic-data-by-operation-id';

                    $response = wp_remote_post( $url , array('body' => $data, 'timeout' => 100 ));
                    $responceData = json_decode(wp_remote_retrieve_body( $response ), TRUE ); 
		    $еlectronicReceipt = null;
		    if(isset($responceData['data'])) {
                    	$еlectronicReceipt = $responceData['data'];
		    }
				

		 			if(!empty($еlectronicReceipt['OperationElectronicDataQrCode']) ){
						$order->update_meta_data( 'OperationElectronicDataQrCode', $еlectronicReceipt['OperationElectronicDataQrCode']);
						$order->update_meta_data( 'OperationElectronicDataReceipt', $еlectronicReceipt['OperationElectronicDataReceipt']);	
						delete_post_meta( $orderID, 'opID');
						$order->save();	
						$order->update_status('printeduuid', 'order_note'); 						

						WC()->mailer()->emails['WC_ElectronicData_Order_Email']->trigger($orderID);
					}	
				}
			}
		}
	}


    register_deactivation_hook (__FILE__, 'checker_deactivate');
       
	function checker_deactivate() {	
		$timestamp = wp_next_scheduled ('wooer_cron');		
		wp_unschedule_event ($timestamp, 'wooer_cron');
	} 

