<?php
/**
 * Plugin Name: Icash tax admin bg
 * Plugin URI: https://icash.bg
 * Author: develop icash
 * Version: 5.3
 * Description: Print cash receipt and get UUID (+ online stores)
 * Text Domain: woo-uuid 
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Domain Path:       /languages
 * @package woo-uuid
 */

/**
 * Check if WooCommerce is active
 **/
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ), true ) ) {

	/**
	* Localisation
	*/
	load_plugin_textdomain( 'woo-uuid', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

	if ( ! class_exists( 'Woo_uuid' ) ) {

	/**
	* Woo_uuid class
	*/
		class Woo_uuid {
	
			public $token;

			public $version;

			public static $plugin_url;
			public static $plugin_path;
			public static $plugin_basefile;
			public static $plugin_basefile_path;
			public static $plugin_text_domain;
		
			/**
			* Set up all the things
			*/
			public function __construct() {
				$this->token   = 'woo-uuid';
				$this->version = '5.3';
				$this->setup();
				$this->define_constants();
				register_activation_hook( __FILE__, array( $this, 'install' ) );
				add_action( 'init', array( $this, 'localise' ) );
			
			}

			/**
			* Installation.
			* Runs on activation. Logs the version number.
			*
			* @access  public
			* @since   1.1.1
			* @return  void
			*/
			public function install() {
				update_option( $this->token . '-version', $this->version );
			}

			/**
			* Setup
			*
			* @return void
			*/
			public function setup() {
		
				include_once( 'includes/settings-form.php');
				include_once( 'includes/addPrintUUIDStatus.php');
								
				include_once( 'includes/cronCheckPendingOrder.php');
				include_once( 'includes/cronCheckWaitingER.php');
				include_once( 'includes/eic.php' ); 	
				//include_once( 'includes/sendDataApiIcash.php');
				include_once( 'includes/notifications.php' ); 	
				include_once( 'includes/wcEmail.php' );	
				include_once( 'includes/vendor/phpqrcode.php' );
				//include_once( 'includes/installed-plugin-details.php' );			
			}
			
			/**
			 * Load the localisation 
			 */
			public function localise() {							
				// Load language files from the wp-content/languages/plugins folder
				$mo_file = WP_LANG_DIR . '/plugins/' . self::$plugin_text_domain . '-' . get_locale() . '.mo';

				if( is_readable( $mo_file ) ) {
					load_textdomain( self::$plugin_text_domain, $mo_file );
				}

				// Otherwise load them from the plugin folder
				load_plugin_textdomain( self::$plugin_text_domain, false, dirname( self::$plugin_basefile ) . '/languages/' );
				add_filter( 'plugin_row_meta', [$this, 'custom_plugin_row_meta'], 10, 2 );
			}

			private function define_constants() {
				self::$plugin_basefile_path = __FILE__;
				self::$plugin_basefile      = plugin_basename( self::$plugin_basefile_path );
				self::$plugin_url           = plugin_dir_url( self::$plugin_basefile );
				self::$plugin_path          = trailingslashit( dirname( self::$plugin_basefile_path ) );	
				self::$plugin_text_domain   = trim( dirname( self::$plugin_basefile ) );	
				
				define( 'CUSTOM_WC_EMAIL_PATH', plugin_dir_path( __FILE__ ) );
				add_option( 'work_with_cashregister', 0);// по подразбиране не се работи с каса			
			}
			
			public function custom_plugin_row_meta( $links, $file ) 
            {
                if ( strpos( $file, 'woo-uuid.php' ) !== false ) {  
                    $new_links = array(
                        '<a href="https://icash.bg/bg/functionalities/woo/" target="_blank">'.__( 'Plugin settings', 'woo-uuid' ).'</a>'
                        );
                
                    $links = array_merge( $links, $new_links );
                }
            
                return $links;
            }
		}

		$testwoo = new Woo_uuid();
	}	

	

	/*add_action( 'woocommerce_before_checkout_process', function() {
		
		$warehouseID    = get_option( 'warehouseid', true );		
		$domain         = get_option( 'domain', true );
        $hasCR          = get_option( 'work_with_cashregister' );

		
		global $wpdb;
		$isHookActive = false;
    	$results = $wpdb->get_results( "SELECT webhook_id, delivery_url, status FROM {$wpdb->prefix}wc_webhooks" );
		foreach($results as $result)
		{
			if(strpos($result->delivery_url, 'create-order-woocommerce') !== false)
			{
				if(strtolower($result->status) != 'active'){
					$isHookActive = false;					
				} else {
					$isHookActive = true;
				}			
			}
		} 

		
        if($warehouseID > 0 && $hasCR && $isHookActive) {
			$url = 'http://'.$domain.'/default/Woocommerce/checkcashregister?whid='.$warehouseID;

			$response = wp_remote_get( $url);

			if( is_wp_error( $response ) ) {
                $text = empty($response->errors['http_request_failed'][0]) ? $domain :$response->errors['http_request_failed'][0];
				wc_add_notice(__( 'Error :' .$text, 'woo-uuid' ), 'error' );
				return false; 
			}

			$body = wp_remote_retrieve_body( $response );

			$data = json_decode( $body );
		
			if( ! empty( $data ) ) {

				if($data->response->error == 'OFFLINE'){ 
                                     wc_add_notice(__( 'The cash register does not include.', 'woo-uuid' ), 'error' );
				};
			}   
		}                             

	});*/

 

// Add custom order status action button (for orders with "processing" status)
add_filter( 'woocommerce_admin_order_actions', 'add_custom_order_status_print_button', 100, 4 );

	function add_custom_order_status_print_button( $actions, $order ) {
	    // Display the button for all orders that have a 'processing' status

	    if ( $order->has_status( array( 'processing','pending' ) ) ) {

            // Get Order ID (compatibility all WC versions)
            $order_id = method_exists( $order, 'get_id' ) ? $order->get_id() : $order->id;
            
            // Set the action button
            $actions['print'] = array(
                'url'       => $order_id,//wp_nonce_url( admin_url( 'admin-ajax.php?action=woocommerce_print_order_admin&status=print&order_id=' . $order_id,'woocommerce-mark-order-status')),  
            //	'url'       => wp_nonce_url( admin_url( 'admin-ajax.php?action=woocommerce_print_order_admin&status=print&order_id=' . $order_id,'woocommerce-mark-order-status')),  
                'name'      => __( 'Print Receipt', 'woo-uuid' ),
                'action'    => "view print", // keep "view" class for a clean button CSS 
            );
	    }
	    
	    return $actions;
	}

// Set the WooCommerce icon for our action button
add_action( 'admin_head', 'add_custom_order_status_actions_button_css' );

	function add_custom_order_status_actions_button_css() {
		
	    	echo '<style>.view.print::after { font-family: icons; content: "\f163" !important; }</style>';

	}    

add_action( 'wp_loaded', 'aj_enqueue_scripts' );

	function aj_enqueue_scripts() {	   

		wp_enqueue_script('jquery'); 
	    	wp_register_script('aj-uuid', plugin_dir_url( __FILE__ ). '/js/aj-uuid-ajax-code.js');

	   
	    	wp_localize_script( 'aj-uuid', 'aj_ajax_uuid', array(
		                'ajax_url' => admin_url( 'admin-ajax.php' ),
		                'aj_demo_nonce' => wp_create_nonce('aj-demo-nonce') 
	    	));

		wp_enqueue_script('aj-uuid');
	}

add_action ('wp_ajax_woocommerce_print_order_admin', 'woocommerce_print_order_admin') ;
	
	function woocommerce_print_order_admin(){
	
		$orderID     = intval( $_GET['order_id'] );
		$warehouseID = get_option( 'warehouseid', true );		
		$domain      = get_option( 'domain', true );
		$onlineStoreID = get_option( 'onlineStoreID', true );		
 	 
        $data = array(
			'orderID' => $orderID,
			'whid'    => $warehouseID,
			'onlineStoreID' => $onlineStoreID
		);
		$url = 'http://'.$domain.'/default/woocommerce/create-woo-order-by-id';	
		
		$requestData = wp_remote_post( $url , array('body' => $data, 'timeout' => 100 ));
		$responceOperation = json_decode(wp_remote_retrieve_body( $requestData ), TRUE );         

		if(isset($responceOperation['data']['error'])){
            custom_notification_helper(__('The cash register does not include.', 'woo-uuid' ), 'error');
			wp_die();
		}
	
 		custom_notification_helper(__('The order is saved in ICASH.', 'woo-uuid' ), 'success');
        wp_die();

	}
	

add_action('admin_menu', 'test_button_menu');

    function test_button_menu(){
        add_menu_page('Test ICASH Page', esc_html( __( 'Test ICASH', 'woo-uuid' )), 'manage_options', 'test-button-slug', 'test_button_admin_page');
    }

    function test_button_admin_page() {

        if (!current_user_can('manage_options'))  {
            wp_die( __('You do not have sufficient pilchards to access this page.')    );
        }

    // Start building the page

        echo '<div class="wrap">';

        echo "<h2>".__( 'Test I-CASH', 'woo-uuid')."</h2>";

        // Check whether the button has been pressed AND also check the nonce
        if (isset($_POST['test_button']) && check_admin_referer('test_button_clicked')) {
            // the button has been pressed AND we've passed the security check
            test_button_action();
        }

        echo '<form action="options-general.php?page=test-button-slug" method="post">';

        wp_nonce_field('test_button_clicked');
        echo '<input type="hidden" value="true" name="test_button" />';
        submit_button(  esc_html(__( 'Check connection with ICASH', 'woo-uuid')));
        echo '</form>';

        echo '</div>';

    }

    function test_button_action()
    {
        echo '<div id="message" class="updated fade"><p>'
            .   __( 'The "Check connection with ICASH" button was clicked.', 'woo-uuid' ) . '</p></div>';
        
        $warehouseID = get_option( 'warehouseid', true );		
        $domain      = get_option( 'domain', true );
            
        $url = 'http://'.$domain.'/default/woocommerce/checkicash?whid='.$warehouseID;

        $response = wp_remote_get( $url, array('timeout'     => 120 ));
    
        if( is_wp_error( $response ) ) {
            $text = empty($response->errors['http_request_failed'][0]) ? $domain :$response->errors['http_request_failed'][0];
            echo '<div id="message" class="error"><p>'.'Error:' .$text. '</p></div>';            
            return false; 
        }

        $body = wp_remote_retrieve_body( $response );

        $data = json_decode( $body );		
        
        if( ! empty( $data ) ) {
            if($data->response == true){                 
                echo '<p>' .  esc_html(__( 'OK: Has connection', 'woo-uuid')) . '</p>';
                echo '<div id="message" class="updated fade"><p>'
                .  esc_html(__( 'OK: Has connection with ICASH.', 'woo-uuid')) . '</p></div>';
            }
        } else {
                echo '<div id="message" class="error"><p>'
                .  esc_html(__( 'Error: Has not connection with ICASH.', 'woo-uuid' )) . '</p></div>';
        }  
    }  	
		
//Check for update 
	
add_filter( 'plugins_api', 'woouuid_plugin_info', 20, 3);

    function woouuid_plugin_info( $res, $action, $args )
    {

        // do nothing if this is not about getting plugin information
        if( 'plugin_information' !== $action ) {
            return $res;
        }

        // do nothing if it is not our plugin
        if( plugin_basename( __DIR__ ) !== $args->slug ) {
            return $res;
        }
	
        $remote = wp_remote_get( 
            'http://v4.nap.dev.icash.bg/program/WooUUID/woodetails.json', 
            array(
                'timeout' => 10,
                'headers' => array(
                    'Accept' => 'application/json'
                ) 
            )
        );
        
     
        // do nothing if we don't get the correct response from the server
        if( 
            is_wp_error( $remote )
            || 200 !== wp_remote_retrieve_response_code( $remote )
            || empty( wp_remote_retrieve_body( $remote ) )
        ) {
            return $res;	
        }

        $remote = json_decode( wp_remote_retrieve_body( $remote ) );
        
        $res = new stdClass();
        $res->name = $remote->name;
        $res->slug = $remote->slug;
        $res->author = $remote->author;
        $res->author_profile = $remote->author_profile;
        $res->version = $remote->version;
        $res->tested = $remote->tested;
        $res->requires = $remote->requires;
        $res->requires_php = $remote->requires_php;
        $res->download_link = $remote->download_url;
        $res->trunk = $remote->download_url;
        $res->last_updated = $remote->last_updated;
        $res->sections = array(
            'description' => $remote->sections->description,
            'installation' => $remote->sections->installation,
            'changelog' => $remote->sections->changelog,
            'new' => $remote->sections->new            
        );
       
        if( ! empty( $remote->sections->screenshots ) ) {
            $res->sections[ 'screenshots' ] = $remote->sections->screenshots;
        }

        $res->banners = array(
            'low' => $remote->banners->low,
            'high' => $remote->banners->high
        );
        
        return $res;
    }


add_filter( 'site_transient_update_plugins', 'woouuid_push_update' );
 
    function woouuid_push_update( $transient )
    {
 
        if ( empty( $transient->checked ) ) {
            return $transient;
        }

        $remote = wp_remote_get( 
            'http://v4.nap.dev.icash.bg/program/WooUUID/woodetails.json',
            array(
                'timeout' => 10,
                'headers' => array(
                    'Accept' => 'application/json'
                )
            )
        );
        
        if( 
            is_wp_error( $remote )
            || 200 !== wp_remote_retrieve_response_code( $remote )
            || empty( wp_remote_retrieve_body( $remote ) )
        ) {
            return $transient;	
        }
	
        $remote = json_decode( wp_remote_retrieve_body( $remote ) );
	
				
        if(
            $remote
            && version_compare( $transient->checked[plugin_basename( __FILE__ )], $remote->version, '<' )
            && version_compare( $remote->requires, get_bloginfo( 'version' ), '<' )
            && version_compare( $remote->requires_php, PHP_VERSION, '<' )
            
        ) {
            $res = new stdClass();
            $res->slug = $remote->slug;
            $res->plugin = plugin_basename( __FILE__ ); 
            $res->new_version = $remote->version;
            $res->tested = $remote->tested;
            $res->package = $remote->download_url;
            $transient->response[ $res->plugin ] = $res;            
        }
 
        return $transient;
    }
    
    
function wporg_settings_init() {
    // register a new setting for "reading" page
    register_setting('reading', 'wporg_setting_name');
 
    // register a new section in the "reading" page
    add_settings_section(
        'wporg_settings_section',
        'WPOrg Settings Section', 'wporg_settings_section_callback',
        'reading'
    );
 
    // register a new field in the "wporg_settings_section" section, inside the "reading" page
    add_settings_field(
        'wporg_settings_field',
        'WPOrg Setting', 'wporg_settings_field_callback',
        'reading',
        'wporg_settings_section'
    );
}
 
/**
 * register wporg_settings_init to the admin_init action hook
 */
add_action('admin_init', 'wporg_settings_init');
 
/**
 * callback functions
 */
 
// section content cb
function wporg_settings_section_callback() {
    echo '<p>WPOrg Section Introduction.</p>';
}
 
// field content cb
function wporg_settings_field_callback() {
    // get the value of the setting we've registered with register_setting()
    $setting = get_option('wporg_setting_name');
    // output the field
    ?>
    <input type="text" name="wporg_setting_name" value="<?php echo isset( $setting ) ? esc_attr( $setting ) : ''; ?>">
    <?php
}


function overrule_webhook_disable_limit($number)
{
    return 100; 
}
add_filter('woocommerce_max_webhook_delivery_failures', 'overrule_webhook_disable_limit');


	
	add_action('woocommerce_webhook_delivery', function($http_args, $response, $duration, $arg, $webhook_id) {
  $responseCode = wp_remote_retrieve_response_code($response);
		//error_log("responseCode=$responseCode");
		//error_log("res =". print_r($response,true));
		//error_log("web+id =$webhook_id");
		//error_log("arg =". print_r($arg,true));
  
}, 1, 5);
}
